import{Fragment,Children,Component,createElement}from"react";import createState from"react-copy-write";import{HashRouter,BrowserRouter,Switch,Route}from"react-router-dom";import createContext from"create-react-context";import{withMDXComponents}from"@mdx-js/tag/dist/mdx-provider";import{MDXProvider}from"@mdx-js/tag";import importedComponent from"react-imported-component";import merge from"deepmerge";import sort from"array-sort";import{NavHashLink}from"react-router-hash-link";import capitalize from"capitalize";const styles={wrapper:{overflowY:"auto",padding:50,display:"flex",flexDirection:"column",alignItems:"center",width:"100vw",height:"100vh",background:"white",fontFamily:"monospace",fontSize:"14px"},page:{maxWidth:960},title:{margin:"0 0 30px"},subtitle:{margin:"30px 0 10px"},stack:{display:"flex",flexDirection:"column"}},ErrorReporter=({error:e,componentStack:t})=>createElement("div",{style:styles.wrapper},createElement("div",{style:styles.page},createElement("h1",{style:styles.title},"🚨 Whoops, we crashed 🚨"),e&&createElement("div",null,e.message),createElement("h2",{style:styles.subtitle},"Stack trace"),t&&createElement("p",{style:styles.stack},t.split("\n").map(e=>createElement("div",null,e)))));class ErrorBoundary extends Component{constructor(){super(...arguments),this.state={error:null,componentStack:null}}componentDidCatch(e,t){this.setState({error:e,componentStack:t?t.componentStack:null})}render(){const{children:e}=this.props,{error:t}=this.state;return null!==t?createElement(ErrorReporter,Object.assign({},this.state)):e}}const state=createState({config:{},entries:{}});class DataServer extends Component{constructor(e,t){const{websocketUrl:r}=e;super(e,t),this.socket=r?new WebSocket(r):null}componentDidMount(){this.socket&&this.setupWebsockets(this.socket)}render(){return this.props.children}setupWebsockets(e){e.onmessage=(e=>{const t=JSON.parse(e.data);"state.entries"===t.type&&state.mutate(e=>{e&&(e.entries=t.payload)}),"state.config"===t.type&&state.mutate(e=>{e&&(e.config=t.payload)})})}}const DefaultWrapper=({children:e})=>createElement(Fragment,null,e),themeContext=createContext({});function theme(e,t){return r=>{const n=n=>{const{wrapper:o=DefaultWrapper,hashRouter:a=!1}=n;return createElement(ErrorBoundary,null,createElement(themeContext.Provider,{value:{themeConfig:e,transform:t,imports:n.imports}},createElement(state.Provider,{initialState:n.db},createElement(DataServer,{websocketUrl:n.websocketUrl},createElement(a?HashRouter:BrowserRouter,{basename:BASE_URL},createElement(o,null,createElement(r,null)))))))};return n.displayName="DoczTheme",n}}const DefaultLoading=()=>createElement(Fragment,null,"Loading"),Identity=({children:e})=>createElement(Fragment,null,e),DefaultRender=({component:e,code:t})=>createElement(Fragment,null,e,t),DefaultNotFound=()=>createElement(Fragment,null,"Not found"),defaultComponents={loading:DefaultLoading,render:DefaultRender,notFound:DefaultNotFound,page:Identity},entriesSelector=state.createSelector(e=>e.entries),DocPreview=({components:e={}})=>{const t=Object.assign({},defaultComponents,e),r=t.page,n=t.notFound,o=t.loading;return createElement(MDXProvider,{components:t},createElement(themeContext.Consumer,null,({imports:e})=>e?createElement(state.Consumer,{select:[entriesSelector]},t=>createElement(Switch,null,Object.keys(e).map(n=>{const a=t&&t[n],l=withMDXComponents(importedComponent(e[n],{LoadingComponent:o}));return a&&createElement(Route,{exact:!0,key:a.id,path:a.route,render:e=>r?createElement(r,Object.assign({},e,{doc:a}),createElement(l,null)):createElement(l,Object.assign({},e))})}),n&&createElement(Route,{component:n}))):createElement(o,null)))};function __rest(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&0>t.indexOf(n)&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);n.length>o;o++)0>t.indexOf(n[o])&&(r[n[o]]=e[n[o]])}return r}const configSelector=state.createSelector(e=>e.config),ThemeConfig=({children:e})=>"function"!=typeof e?null:createElement(themeContext.Consumer,null,({themeConfig:t,transform:r})=>createElement(state.Consumer,{select:[configSelector]},n=>{var{themeConfig:o}=n,a=__rest(n,["themeConfig"]);const l=merge(t,o);return Children.only(e(Object.assign({},a,{themeConfig:r?r(l):l})))})),isFn=e=>"function"==typeof e,sortBy=(e,t,r)=>t>e?r?1:-1:e>t?r?-1:1:0,menuFromEntries=e=>Array.from(new Set(e.reduce((e,t)=>t.menu?e.concat([t.menu]):e,[]))),Docs=({children:e})=>"function"!=typeof e?null:createElement(state.Consumer,{select:[entriesSelector,configSelector]},(t,r)=>{if(!t||!e)return null;if(!isFn(e))throw Error("You need to pass a children as a function to your <Docs/> component");const n=Object.values(t),o=menuFromEntries(n),a=sort(o,(e,t)=>sortBy(e,t)),l="descending"===r.ordering,s=sort(n,(e,t)=>sortBy(e.order,t.order,l),(e,t)=>sortBy(e.name,t.name));return Children.only(e({menus:a,docs:s}))}),Link=e=>createElement(NavHashLink,Object.assign({},e,{exact:!0})),BasePlayground=({components:e,className:t,style:r,wrapper:n=Identity,children:o,__position:a,__code:l})=>e&&e.render?createElement(e.render,{className:t,style:r,components:e,component:createElement(n,null,isFn(o)?o():o),position:a,code:l}):null,Playground=withMDXComponents(BasePlayground),RE_OBJECTOF=/(?:React\.)?(?:PropTypes\.)?objectOf\((?:React\.)?(?:PropTypes\.)?(\w+)\)/,getTypeStr=e=>{switch(e.name.toLowerCase()){case"instanceof":return`Class(${e.value})`;case"enum":return e.value?e.value.map(e=>`${e.value}`).join(" │ "):e.raw;case"union":return e.value?e.value.map(e=>`${getTypeStr(e)}`).join(" │ "):e.raw;case"array":return e.raw;case"arrayof":return`Array<${getTypeStr(e.value)}>`;case"custom":if(-1!==e.raw.indexOf("function")||-1!==e.raw.indexOf("=>"))return"Custom(Function)";if(-1!==e.raw.toLowerCase().indexOf("objectof")){const t=e.raw.match(RE_OBJECTOF);return t&&t[1]?`ObjectOf(${capitalize(t[1])})`:"ObjectOf"}return"Custom";case"bool":return"Boolean";case"func":return"Function";case"shape":const t=e.value,r={};return Object.keys(t).forEach(e=>{r[e]=getTypeStr(t[e])}),JSON.stringify(r,null,2);default:return capitalize(e.name)}},humanize=e=>getTypeStr(e),getPropType=(e,t)=>{const r=e.flowType?e.flowType.name:e.type.name,n=r.startsWith('"'),o=capitalize(n?"enum":r);return o?t&&(e.flowType||n||e.type&&e.type.value)?e.flowType&&!e.flowType.elements?o:createElement(t,e.flowType?{text:humanize(e.flowType)}:{text:humanize(e.type)},o):o:null},BasePropsTable=({of:e,components:t})=>{const r=e.__docgenInfo,n=r&&r.props;if(!r||!n)return null;const o=t.tr||"tr",a=t.th||"th",l=t.tbody||"tbody",s=t.td||"td",c=t.tooltip;return createElement(Fragment,null,createElement(t.table||"table",{className:"PropsTable"},createElement(t.thead||"thead",null,createElement(o,null,createElement(a,{className:"PropsTable--property"},"Property"),createElement(a,{className:"PropsTable--type"},"Type"),createElement(a,{className:"PropsTable--required"},"Required"),createElement(a,{className:"PropsTable--default"},"Default"),createElement(a,{width:"40%",className:"PropsTable--description"},"Description"))),createElement(l,null,n&&Object.keys(n).map(e=>{const t=n[e];return t.flowType||t.type?createElement(o,{key:e},createElement(s,null,e),createElement(s,null,getPropType(t,c)),createElement(s,null,t.required+""),createElement(s,null,t.defaultValue&&t.defaultValue.value.replace(/\'/g,"")),createElement(s,null,t.description&&t.description)):null}))))},PropsTable=withMDXComponents(BasePropsTable);export{theme,Docs,Link,Playground,PropsTable,ThemeConfig,DocPreview};
//# sourceMappingURL=index.m.js.map
